diff --git a/gcc/config/arc/arc-arch.h b/gcc/config/arc/arc-arch.h
index 832338b..2344a4b 100644
--- a/gcc/config/arc/arc-arch.h
+++ b/gcc/config/arc/arc-arch.h
@@ -47,6 +47,23 @@ enum base_architecture
     BASE_ARCH_END
   };
 
+/* Architecture specific propoerties.  */
+
+typedef struct
+{
+  /* Architecture name.  */
+  const char *const name;
+
+  /* Architecture class.  */
+  enum base_architecture arch_id;
+
+  /* All allowed flags for this architecture.  */
+  const unsigned long long flags;
+
+  /* Default flags for this architecture.  It is a subset of
+     FLAGS.  */
+  const unsigned long long dflags;
+} arc_arch_t;
 
 /* Tune variants.  Needs to match the attr_tune enum.  */
 
@@ -66,7 +83,7 @@ typedef struct
   const char *const name;
 
   /* Architecture class.  */
-  enum base_architecture arch;
+  const arc_arch_t *arch_info;
 
   /* Specific processor type.  */
   enum processor_type processor;
@@ -76,28 +93,8 @@ typedef struct
 
   /* Tune value.  */
   enum arc_tune_attr tune;
-} arc_cpu_t;
-
-
-/* Architecture specific propoerties.  */
-
-typedef struct
-{
-  /* Architecture name.  */
-  const char *const name;
-
-  /* Architecture class.  */
-  enum base_architecture arch;
-
-  /* All allowed flags for this architecture.  */
-  const unsigned long long flags;
-
-  /* Default flags for this architecture.  It is a subset of
-     FLAGS.  */
-  const unsigned long long dflags;
-} arc_arch_t;
-
 
+} arc_cpu_t;
 
 const arc_arch_t arc_arch_types[] =
   {
@@ -111,13 +108,16 @@ const arc_arch_t arc_arch_types[] =
 
 const arc_cpu_t arc_cpu_types[] =
   {
-    {"none", BASE_ARCH_NONE, PROCESSOR_NONE, 0, ARC_TUNE_NONE},
+    {"none", NULL, PROCESSOR_NONE, 0, ARC_TUNE_NONE},
 #define ARC_CPU(NAME, ARCH, FLAGS, TUNE)	\
-    {#NAME, BASE_ARCH_##ARCH, PROCESSOR_##NAME, FLAGS, ARC_TUNE_##TUNE},
+    {#NAME, &arc_arch_types [BASE_ARCH_##ARCH], PROCESSOR_##NAME, FLAGS, ARC_TUNE_##TUNE },
 #include "arc-cpus.def"
 #undef ARC_CPU
-    {NULL, BASE_ARCH_END, PROCESSOR_NONE, 0, ARC_TUNE_NONE}
+    {NULL, NULL, PROCESSOR_NONE, 0, ARC_TUNE_NONE}
   };
 
+/* Currently selected cpu type.  */
+extern const arc_cpu_t *arc_selected_cpu;
+
 #endif
 #endif /* GCC_ARC_ARCH_H */
diff --git a/gcc/config/arc/arc.c b/gcc/config/arc/arc.c
index 9089ef4..8a838f9 100644
--- a/gcc/config/arc/arc.c
+++ b/gcc/config/arc/arc.c
@@ -243,11 +243,8 @@ static bool arc_use_by_pieces_infrastructure_p (unsigned HOST_WIDE_INT,
 						enum by_pieces_operation op,
 						bool);
 
-static const arc_cpu_t *arc_selected_cpu;
-static const arc_arch_t *arc_selected_arch;
-
-/* Global var which sets the current compilation architecture.  */
-enum base_architecture arc_base_cpu;
+/* Globally visible information about currently selected cpu.  */
+const arc_cpu_t *arc_selected_cpu;
 
 /* Implements target hook vector_mode_supported_p.  */
 
@@ -787,11 +784,9 @@ arc_override_options (void)
 
   /* Set the default cpu options.  */
   arc_selected_cpu = &arc_cpu_types[(int) arc_cpu];
-  arc_selected_arch = &arc_arch_types[(int) arc_selected_cpu->arch];
-  arc_base_cpu = arc_selected_arch->arch;
 
   /* Set the architectures.  */
-  switch (arc_selected_arch->arch)
+  switch (arc_selected_cpu->arch_info->arch_id)
     {
     case BASE_ARCH_em:
       arc_cpu_string = "EM";
@@ -822,16 +817,16 @@ arc_override_options (void)
     if ((arc_selected_cpu->flags & CODE)		\
 	&& ((target_flags_explicit & MASK) == 0))	\
       target_flags |= MASK;				\
-    if (arc_selected_arch->dflags & CODE)		\
+    if (arc_selected_cpu->arch_info->dflags & CODE)	\
       target_flags |= MASK;				\
   } while (0);
-#define ARC_OPTX(NAME, CODE, VAR, VAL, DOC)	\
-  do {						\
-    if ((arc_selected_cpu->flags & CODE)	\
-	&& (VAR == DEFAULT_##VAR))		\
-      VAR = VAL;				\
-    if (arc_selected_arch->dflags & CODE)	\
-      VAR = VAL;				\
+#define ARC_OPTX(NAME, CODE, VAR, VAL, DOC)		\
+  do {							\
+    if ((arc_selected_cpu->flags & CODE)		\
+	&& (VAR == DEFAULT_##VAR))			\
+      VAR = VAL;					\
+    if (arc_selected_cpu->arch_info->dflags & CODE)	\
+      VAR = VAL;					\
   } while (0);
 
 #include "arc-options.def"
@@ -844,18 +839,18 @@ arc_override_options (void)
 #define ARC_OPTX(NAME, CODE, VAR, VAL, DOC)			\
   do {								\
     if ((VAR == VAL)						\
-	&& (!(arc_selected_arch->flags & CODE)))		\
+	&& (!(arc_selected_cpu->arch_info->flags & CODE)))	\
       {								\
 	error ("%s is not available for %s architecture",	\
-	       DOC, arc_selected_arch->name);			\
+	       DOC, arc_selected_cpu->arch_info->name);		\
       }								\
   } while (0);
 #define ARC_OPT(NAME, CODE, MASK, DOC)				\
   do {								\
     if ((target_flags & MASK)					\
-	&& (!(arc_selected_arch->flags & CODE)))		\
+	&& (!(arc_selected_cpu->arch_info->flags & CODE)))	\
       error ("%s is not available for %s architecture",		\
-	     DOC, arc_selected_arch->name);			\
+	     DOC, arc_selected_cpu->arch_info->name);		\
   } while (0);
 
 #include "arc-options.def"
diff --git a/gcc/config/arc/arc.h b/gcc/config/arc/arc.h
index 9cf7668..d6d9012 100644
--- a/gcc/config/arc/arc.h
+++ b/gcc/config/arc/arc.h
@@ -215,15 +215,16 @@ extern const char *arc_cpu_to_as (int argc, const char **argv);
    use conditional execution?  */
 #define TARGET_AT_DBR_CONDEXEC  (!TARGET_ARC700 && !TARGET_V2)
 
-extern enum base_architecture arc_base_cpu;
-
-#define TARGET_ARC600 ((arc_base_cpu == BASE_ARCH_6xx)	\
+#define TARGET_ARC600 ((arc_selected_cpu->arch_info->arch_id	\
+			== BASE_ARCH_6xx)			\
 		       && (TARGET_BARREL_SHIFTER))
-#define TARGET_ARC601 ((arc_base_cpu == BASE_ARCH_6xx)	\
+#define TARGET_ARC601 ((arc_selected_cpu->arch_info->arch_id	\
+			== BASE_ARCH_6xx)			\
 		       && (!TARGET_BARREL_SHIFTER))
-#define TARGET_ARC700 (arc_base_cpu == BASE_ARCH_700)
-#define TARGET_EM (arc_base_cpu == BASE_ARCH_em)
-#define TARGET_HS (arc_base_cpu == BASE_ARCH_hs)
+#define TARGET_ARC700 (arc_selected_cpu->arch_info->arch_id	\
+		       == BASE_ARCH_700)
+#define TARGET_EM (arc_selected_cpu->arch_info->arch_id == BASE_ARCH_em)
+#define TARGET_HS (arc_selected_cpu->arch_info->arch_id == BASE_ARCH_hs)
 #define TARGET_V2 (TARGET_EM || TARGET_HS)
 
 #ifdef ARC_MULTILIB_CPU_DEFAULT
diff --git a/gcc/config/arc/driver-arc.c b/gcc/config/arc/driver-arc.c
index 4b816e6..0e13878 100644
--- a/gcc/config/arc/driver-arc.c
+++ b/gcc/config/arc/driver-arc.c
@@ -47,7 +47,7 @@ arc_cpu_to_as (int argc, const char **argv)
 	}
     }
 
-  switch (arc_selected_cpu->arch)
+  switch (arc_selected_cpu->arch_info->arch_id)
     {
     case BASE_ARCH_em:
       if (arc_selected_cpu->flags & FL_CD)